PROGRAM TEST_SOL
! ----------------------------------------------------------------------
!        Dissertation            DI KOFLER Peter 9126050        E086 869

! 1.     PROGRAM UNIT 'TEST_SOL' - Test komplettes SOLSIIVP Modul
!        FORTRAN 90 PROGRAM

! 2.     Funktion: Diss, Kapitel 8.

! 7.     Datum 28-01-1998                                   Version 1.00
!        Letzte Verbesserung 28-01-1998
! ----------------------------------------------------------------------
   USE types
   USE solsiivp
   USE fun, ONLY : fcn, initial, neqn, dfcn, linear, true
   IMPLICIT NONE

   LOGICAL, PARAMETER :: all = .false.
   REAL(KIND = dp) :: y(neqn), tol, eps, h, a, b, hmin, hmax, tglobal, &
                      tlocal, xsw, w(neqn)
   INTEGER(KIND = i4b) :: ifail, i, method

! ----------------------------------------------------------------------
      WRITE(*,'(A)') ' Test SOLSIIVP-Modul'
! ----------------------------------------------------------------------
!        Variablen initialisieren
! ----------------------------------------------------------------------

!        neqn = Anzahl Gleichungen des Systems
   WRITE(*,'(A,I2)') ' Die Dimension des Systems ist', neqn

!        Anfangswerte setzen
   CALL Initial(a, b, y)
   WRITE(*,'(A)') ' ES WIRD INTEGRIERT VON'
   WRITE(*,*) a
   WRITE(*,'(A)') ' BIS'
   WRITE(*,*) b

   xsw = -1.0_dp
   IF (all) THEN
      WRITE(*,'(A)') ' Umschaltpunkt: '
      READ(*,*) xsw
      WRITE(*,*) xsw
   END IF


   WRITE(*,'(A)') ' ANFANGSWERT Y(A)'
   DO i = 1, neqn
       WRITE(*,*) y(i)
   END DO

!        Fehlerschranke
   WRITE(*,'(A)') ' gesamte FEHLERTOLERANZ: '
   READ(*,*) tol
   WRITE(*,*) tol

   tlocal = tol
   tglobal = tol
   eps = tol / 10.0_dp
   h = -1.0_dp
   IF (all) THEN
      WRITE(*,'(A)') ' globale FEHLERTOLERANZ: '
      READ(*,*) tglobal
      WRITE(*,*) tglobal

      WRITE(*,'(A)') ' lokale FEHLERTOLERANZ: '
      READ(*,*) tlocal
      WRITE(*,*) tlocal

!        Newton
      WRITE(*,'(A)') ' NEWTON-FEHLERTOLERANZ: '
      eps = 1.0d-14
   !   READ(*,*) eps
      WRITE(*,*) eps

!        Start h
      WRITE(*,'(A)') ' STARTSCHRITTWEITE(H): '
      READ(*,*) h
      WRITE(*,*) h

      WRITE(*,'(A)') ' Hmin: '
      READ(*,*) hmin
      WRITE(*,*) hmin

      WRITE(*,'(A)') ' Hmax: '
      READ(*,*) hmax
      WRITE(*,*) hmax
   END IF

   method = 4
   ifail = 0

! ----------------------------------------------------------------------
!        Los gehts
! ----------------------------------------------------------------------

   WRITE(*,'(A)') ' STARTE SUBROUTINE'

   IF (all) THEN
   CALL ivp_sing(fcn, a, y, b, tol, ifail, dfcn, linear, method, &
                 xsw, h, hmin, hmax, tglobal, tlocal, eps)
   ELSE
   CALL ivp_sing(fcn, a, y, b, tol, ifail, dfcn, linear, method, &
                 xsw, h, global_tol=tglobal, local_tol=tlocal, &
                 Newton_tol=eps)
   END IF
   WRITE(*,*) ' IFAIL: ', ifail

   WRITE(*,'(A)') ' aktuelle StartSCHRITTWEITE: '
   WRITE(*,*) h
   WRITE(*,'(A)') ' Umschaltpunkt'
   WRITE(*,*) xsw
   WRITE(*,'(A)') ' DIE GLOBALE FEHLERSCHAETZUNG bei xsw ist '
   WRITE(*,*) tglobal

   WRITE(*,'(A)') ' INTEGRIERT WURDE BIS'
   WRITE(*,*) a
   WRITE(*,'(A)') ' DIE LOESUNG DORT IST'
   DO i = 1, neqn
      WRITE(*,*) y(i)
   END DO
   WRITE(*,'(A)') ' DIE lokale FEHLERSCHAETZUNG bei b ist '
   WRITE(*,*) tlocal
   WRITE(*,'(A)') ' Der globale Fehler der LOESUNG IST'
   w = true(a)
   DO i = 1, neqn
      WRITE(*,*) y(i)-w(i)
   END DO

   STOP

END PROGRAM TEST_SOL
